{ open Parser }

rule token = parse
  [' ' '\t' '\r' '\n'] { token lexbuf }
(*punctuations*)
| '+' { PLUS } (*operators*)
| '-' { MINUS }
| '*' { TIMES }
| '/' { DIVIDE }
| '%' { MOD }
| ">=" { LE }
| "<=" { SE }
| "==" { EQ }
| "!=" {NEQ}
| '>' { LARGER }
| '<' { SMALLER } 
| '(' { LPAREN }
| ')' { RPAREN }
| '[' { LBRACK }
| ']' { RBRACK }
| ';' {SEMICOLON}
| ',' {COMMA}
| '#' { COMMENT }
| '.' { DOLLAR}
| '=' { ASSIGN } 
| "&&" { AND }
| "||" { OR }
| '~' { NOT }
| "void" {VOID}
| "integer" { INTEGER } (*types*)
| "string" { STRING }
| "float" { FLOAT }
| "bool" { BOOL }
| "Line" { LINE }
| "Circle" { CIRCLE }
| "Point" { POINT }
| "if" { IF }(*controlling sequence*)
| "else" { ELSE }
| "then" { THEN }
| "elif" { ELIF }
| "end" { END }
| "for" { FOR }
| "while" { WHILE }
| "break" { BREAK }
| "continue" { CONTINUE }
| "return" { RETURN }
| "pass" {PASS}
| "library" {LIB}
| "do" {DO}
| "true" { BOL(true) }
| "false"  { BOL(false) } 
| ['0'-'9']+ as lit { INT(int_of_string lit) }
| ['0'-'9']*'.'['0'-'9']+ as lit { FLO(float_of_string lit) }
| '"'[^'"']*'"' as lit { STR(lit) }
| ['A'-'Z' 'a'-'z']+['A'-'Z' 'a'-'z' '0'-'9']* as lit { ID(lit) }
| eof { EOF }
| _  {raise (Failure("illegal character"))}